题解 洛谷 Luogu P2440 木材加工 二分答案 C/C++

题目传送门:

P2440 木材加工 - 洛谷 | 计算机科学教育新生态https://www.luogu.com.cn/problem/P2440思路

很简单的二分答案

每次找区间中点 m,判断每段长度为 m 时木头段总数是否 >= k 即可

有两个细节需要注意一下

1.left 初始值应为 1 而非 0,否则有可能出现除以 0 的情况 (没错,我 RE 了 2 个点才想起来)

2.一开始我是把 r 设定为 arri 最小值的,这样 AC 了 6/8 的测试点

为什么会剩 2 个点 WA 呢,因为有这样的数据:n = 3, k = 2, arr = { 1, 3, 3 }

要分成 2 段木头,易知答案为 3。这种情况下 r 设定为 arri 最小值就不对了

因为有些短木头连一段都算不上,直接被舍弃了

所以 r 应设定为 arri 最大值

代码:

cpp 复制代码
#include <cstdio>
using namespace std;
const int N = 1E5 + 10;
int arr[N], n, k, l = 1, r, m, ans;
{
	int ret = 0;
	for (int i = 0; i < n; i++)
	{
		ret += arr[i] / m;
		if (ret >= k) return true;
	}
	return false;
}
int main()
{
	scanf("%d%d", &n, &k);
	for (int i = 0; i < n; i++)
	{
		scanf("%d", &arr[i]);
		if (arr[i] > r) r = arr[i];
	}
	while (l <= r)
	{
		m = l + r >> 1;
		if (mp(m)) ans = m, l = m + 1;
		else r = m - 1;
	}
	printf("%d", ans);//ans 一次都没更新过的话就是 0,符合题目要求
	return 0;
}
相关推荐
会编程的小孩18 分钟前
C++ qt的安装
c++
学逆向的23 分钟前
C 枚举变量
c语言·开发语言·网络安全
冷凝雨42 分钟前
前导零、后导零、最高有效位、最低有效位计算(C)
c语言
鸥梨菌Honevid1 小时前
C 语言 restrict 关键字深度解析:从“独占访问”承诺到编译器激进优化
c语言
企业数字化笔记3 小时前
视频人体姿态怎么做三维可视化?2D关键点、深度局限与技术选型
人工智能·算法·音视频
?abc!3 小时前
(数组)581. 最短无序连续子数组
数据结构·算法·leetcode
小成202303202656 小时前
C++~07补充
开发语言·c++
小郎君6586 小时前
MPTT树复选框的半选状态:一棵百万节点树从递归到计数器,再到区间覆盖
算法
酌沧6 小时前
MemT让记忆成为模型内生能力
jvm·人工智能·算法
水饺编程6 小时前
第2章:Linux 基础,切换用户
linux·c语言·汇编